// Copyright 2017 PDFium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Original code copyright 2014 Foxit Software Inc. http://www.foxitsoftware.com

#include "xfa/fxfa/parser/cxfa_tooltip.h"

#include "fxjs/xfa/cjx_tooltip.h"
#include "third_party/base/ptr_util.h"

namespace {

const CXFA_Node::AttributeData kToolTipAttributeData[] = {
    {XFA_Attribute::Id, XFA_AttributeType::CData, nullptr},
    {XFA_Attribute::Rid, XFA_AttributeType::CData, nullptr},
    {XFA_Attribute::Use, XFA_AttributeType::CData, nullptr},
    {XFA_Attribute::Usehref, XFA_AttributeType::CData, nullptr},
    {XFA_Attribute::Unknown, XFA_AttributeType::Integer, nullptr}};

constexpr wchar_t kToolTipName[] = L"toolTip";

}  // namespace

CXFA_ToolTip::CXFA_ToolTip(CXFA_Document* doc, XFA_PacketType packet)
    : CXFA_Node(doc,
                packet,
                (XFA_XDPPACKET_Template | XFA_XDPPACKET_Form),
                XFA_ObjectType::TextNode,
                XFA_Element::ToolTip,
                nullptr,
                kToolTipAttributeData,
                kToolTipName,
                pdfium::MakeUnique<CJX_ToolTip>(this)) {}

CXFA_ToolTip::~CXFA_ToolTip() {}
